package cz.zcu.kiv.db.dao;

import java.util.ArrayList;
import java.util.List;

import cz.zcu.kiv.db.model.osoby.Aktivita;
import cz.zcu.kiv.db.model.osoby.Osoba;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;

/**
 * 
 * @author Jaroslav Pavuk
 *
 */
public class OsobaDaoImpl implements OsobaDao {

	protected final Log logger = CmsLog.getLog(OsobaDaoImpl.class);

	private ArrayList<Osoba> osoby = null;

	private ArrayList<Aktivita> aktivity = null;

	private ArrayList<Osoba> getListOsoby(){
		if (osoby == null) {
			osoby = new ArrayList<Osoba>();

			osoby.add(new Osoba(1, "Jan", "Novak 1", "jn1", "jan.novak1@kiv.zcu.cz"));
			osoby.add(new Osoba(2, "Jan", "Novak 2", "jn2", "jan.novak2@kiv.zcu.cz"));
			osoby.add(new Osoba(3, "Jan", "Novak 3", "jn3", "jan.novak3@kiv.zcu.cz"));
			osoby.add(new Osoba(4, "Jan", "Novak 4", "jn4", "jan.novak4@kiv.zcu.cz"));
		}
		return osoby;
	}

	private ArrayList<Aktivita> getListAktivity(){
		if (aktivity == null) {
			aktivity = new ArrayList<Aktivita>();

			aktivity.add(new Aktivita(1, "Aktivita1"));
			aktivity.add(new Aktivita(2, "Aktivita2"));
			aktivity.add(new Aktivita(3, "Aktivita3"));
			aktivity.add(new Aktivita(4, "Aktivita4"));
		}
		return aktivity;
	}

	@Override
	public Osoba getOsobaById(int id) {
		logger.debug("Hledani osoby s id: '" + id + "'.");
		System.out.println("Hledani osoby s id: '" + id + "'.");
		Osoba osoba = null;
		for (int i = 0; i < getListOsoby().size(); i++) {
			if (getListOsoby().get(i).getId() == id) {
				osoba = getListOsoby().get(i);
				logger.debug("Osoba nalezena.");
				break;
			}
		}
		return osoba;
	}

	@Override
	public Osoba getOsobaByLogin(String loginName) {
		logger.debug("Hledani osoby s login: '" + loginName + "'.");
		System.out.println("Hledani osoby s login: '" + loginName + "'.");
		Osoba osoba = null;	
		for (int i = 0; i < getListOsoby().size(); i++) {
			if ((getListOsoby().get(i).getLogin()).equals(loginName)) {
				osoba = getListOsoby().get(i);
				logger.debug("Osoba nalezena.");
				break;
			}
		}
		return osoba;
	}

	@Override
	public List<Osoba> getOsoby() {
		logger.debug("Ziskani seznamu osob.");
		logger.debug("Pocet nalezenych osob: " + getListOsoby().size());
		System.out.println("Pocet nalezenych osob: " + getListOsoby().size());
		return getListOsoby();
	}

	@Override
	public void smazOsobu(Osoba osoba) {
		logger.debug("Mazani osoby s id: '" + osoba.getId() + "'.");
		System.out.println("Mazani osoby s id: '" + osoba.getId() + "'.");
		for (int i = 0; i < getListOsoby().size(); i++) {
			if (getListOsoby().get(i).getId() == osoba.getId()) {
				getListOsoby().remove(i);
				logger.debug("Osoba byla smazana.");
				break;
			}
		}
	}

	@Override
	public Osoba ulozOsobu(Osoba osoba) {
		logger.debug("Ukladani osoby: " + osoba.getId());
		
		Osoba pom = null;
		for(int i = 0; i < getListOsoby().size(); i++){
			if(getListOsoby().get(i).getId() == osoba.getId()){
				pom = getListOsoby().set(i, osoba);
				logger.debug("Aktualizuji osobu: " + osoba.getId());
				break;
			}
		}

		//nova osoba
		if(pom == null){
			//TODO
			if(osoba.getId() == 0){
				int maxId = 0;
				for(Osoba akt : getListOsoby()){
					if(akt.getId() > maxId){
						maxId = akt.getId();
					}
				}
				maxId++;
				osoba.setId(maxId);
			}

			getListOsoby().add(osoba);
			logger.debug("Osobu pridana.");

			pom = osoba;
		}

		return pom;
	}

	@Override
	public List<Aktivita> getAktivity() {
		logger.debug("Ziskani seznamu aktivit.");
		logger.debug("Pocet nalezenych aktivit: " + getListAktivity().size());
		System.out.println("Pocet nalezenych aktivit: " + getListAktivity().size());
		return getListAktivity();
	}

	@Override
	public Aktivita getAktivitaById(int id) {
		logger.debug("Hledani aktivity s id: '" + id + "'.");
		System.out.println("Hledani aktivity s id: '" + id + "'.");
		Aktivita aktivita = null;	
		for (int i = 0; i < getListAktivity().size(); i++) {
			if (getListAktivity().get(i).getId() == id) {
				aktivita = getListAktivity().get(i);
				logger.debug("Aktivita nalezena.");
				break;
			}
		}
		return aktivita;
	}

	@Override
	public void smazAktivitu(Aktivita aktivita) {
		logger.debug("Mazani aktivity s id: '" + aktivita.getId() + "'.");
		System.out.println("Mazani aktivity s id: '" + aktivita.getId() + "'.");
		for (int i = 0; i < getListAktivity().size(); i++) {
			if (getListAktivity().get(i).getId() == aktivita.getId()) {
				getListAktivity().remove(i);
				logger.debug("Aktivita byla smazana.");
				break;
			}
		}
	}

	@Override
	public Aktivita ulozAktivitu(Aktivita aktivita) {

		logger.debug("Ukladani aktivity: " + aktivita.getPopisCz());

		Aktivita pom = null;
		for(int i = 0; i < getListAktivity().size(); i++){
			if(getListAktivity().get(i).getId() == aktivita.getId()){
				pom = getListAktivity().set(i, aktivita);
				logger.debug("Aktivita aktualizovana.");
				break;
			}
		}

		//nova aktivita
		if(pom == null){
			//TODO
			if(aktivita.getId() == 0){
				int maxId = 0;
				for(Aktivita akt : getListAktivity()){
					if(akt.getId() > maxId){
						maxId = akt.getId();
					}
				}
				maxId++;
				aktivita.setId(maxId);
			}

			getListAktivity().add(aktivita);
			logger.debug("Aktivita pridana.");

			pom = aktivita;
		}

		return pom;
	}
}
