package cz.zcu.kiv.db.model.osoby;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Osoba implements Serializable{

	private static final long serialVersionUID = 4201589510379271656L;

	private int id;

	private List<Aktivita> aktivity;

	private String login;
	private String jmeno;
	private String prijmeni;

	private String telefonExt;
	private String titulyZa;
	private String titulyPred;
	private String email;
	private boolean jeExterni;
	private String extPracovisteCz;
	private String extPracovisteEn;

	private String url;
	private String kancelar;
	private Integer telefonZcu;
	private String uredniHodiny;

	private boolean jeDoktorand;
	private Osoba skolitel;
	private Integer doktRokNastupu;  

	/**
	 * Public constructor.
	 * 
	 * @param jmeno
	 * @param prijmeni
	 * @param email
	 */
	public Osoba(int id, String jmeno, String prijmeni, String login, String email) {
		this.id = id;
		this.jmeno = jmeno;
		this.prijmeni = prijmeni;
		this.login = login;
		this.email = email;
	}
	
	/**
	 * Public constructor.
	 * 
	 * @param jmeno
	 * @param prijmeni
	 * @param login
	 * @param email
	 */
	public Osoba(String jmeno, String prijmeni, String login, String email) {
		this.jmeno = jmeno;
		this.prijmeni = prijmeni;
		this.login = login;
		this.email = email;
	}

	/**
	 * Public constructor.
	 */
	public Osoba() {}

	/**
	 * 
	 * @param aktivita
	 */
	public void pridejAktivitu(Aktivita aktivita){
		
		//System.out.println("Pridavani aktivity s id: '" + aktivita.getId() + " osobe: " + id + "'.");
		
		if(aktivity == null){
			aktivity = new ArrayList<Aktivita>();
		}

		for(int i = 0; i < aktivity.size(); i++){
			if(aktivity.get(i).getId() == aktivita.getId()){
				aktivity.set(i, aktivita);
				return;
			}
		}
		aktivity.add(aktivita);
	}

	public void odeberAktivitu(Aktivita aktivita){
		if(aktivity != null){
			for(int i = 0; i < aktivity.size(); i++){
				if(aktivity.get(i).getId() == aktivita.getId()){
					aktivity.remove(i);
					break;
				}
			}
		}
	}



	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Override
	public String toString() {
		return "id: " + id + ", prijmeni: " + prijmeni + ",jmeno: " + jmeno + ", email: " + email;
	}


	public List<Aktivita> getAktivity () {
		return aktivity;
	}

	public void setAktivity(List<Aktivita> val) {
		this.aktivity = val;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getTitulyPred() {
		return titulyPred;
	}

	public void setTitulyPred(String titulyPred) {
		this.titulyPred = titulyPred;
	}

	public String getJmeno() {
		return jmeno;
	}

	public void setJmeno(String jmeno) {
		this.jmeno = jmeno;
	}

	public String getPrijmeni() {
		return prijmeni;
	}

	public void setPrijmeni(String prijmeni) {
		this.prijmeni = prijmeni;
	}

	public String getTitulyZa() {
		return titulyZa;
	}

	public void setTitulyZa(String titulyZa) {
		this.titulyZa = titulyZa;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public Integer getTelefonZcu() {
		return telefonZcu;
	}

	public void setTelefonZcu(Integer telefonZcu) {
		this.telefonZcu = telefonZcu;
	}

	public String getKancelar() {
		return kancelar;
	}

	public void setKancelar(String kancelar) {
		this.kancelar = kancelar;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getUredniHodiny() {
		return uredniHodiny;
	}

	public void setUredniHodiny(String uredniHodiny) {
		this.uredniHodiny = uredniHodiny;
	}

	public boolean isJeExterni() {
		return jeExterni;
	}

	public void setJeExterni(boolean jeExterni) {
		this.jeExterni = jeExterni;
	}

	public String getExtPracovisteCz() {
		return extPracovisteCz;
	}

	public void setExtPracovisteCz(String extPracovisteCz) {
		this.extPracovisteCz = extPracovisteCz;
	}

	public String getExtPracovisteEn() {
		return extPracovisteEn;
	}

	public void setExtPracovisteEn(String extPracovisteEn) {
		this.extPracovisteEn = extPracovisteEn;
	}


	public String getTelefonExt() {
		return telefonExt;
	}

	public void setTelefonExt(String telefonExt) {
		this.telefonExt = telefonExt;
	}

	public boolean isJeDoktorand() {
		return jeDoktorand;
	}

	public void setJeDoktorand(boolean jeDoktorand) {
		this.jeDoktorand = jeDoktorand;
	}

	public Osoba getSkolitel() {
		return skolitel;
	}

	public void setSkolitel(Osoba skolitel) {
		this.skolitel = skolitel;
	}

	public Integer getDoktRokNastupu() {
		return doktRokNastupu;
	}

	public void setDoktRokNastupu(Integer doktRokNastupu) {
		this.doktRokNastupu = doktRokNastupu;
	}
}

