package cz.zcu.kiv.opencms.springmvcapp.controllers;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.opencms.springmvcapp.services.OsobaManager;

public class NovaOsobaPrehledController implements Controller {

	public static final String NOVA_OSOBA_PARAM_NAME = "novaosoba";

	private OsobaManager osobaManager;

	protected final Log logger = CmsLog.getLog(this.getClass());

	@Override
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
		String novaOsobaLogin =  request.getParameter(NovaOsobaPrehledController.NOVA_OSOBA_PARAM_NAME);

		logger.info("Nacitam novou osobu podle loginu: " + novaOsobaLogin );
		Osoba novaOsoba = osobaManager.getOsobaByLogin(novaOsobaLogin); 
		logger.info("Osoba: " + novaOsobaLogin + " byla nactena. ");

		if(novaOsoba != null){

			logger.info("Zobrazuji osobu:" + novaOsoba.getJmeno() + " " + novaOsoba.getPrijmeni());

			return new ModelAndView("novaosobaprehled","novaosoba",novaOsoba);
		}
		else{
			String message = "Pri vytvareni nove osoby se vyskytla chyba.";
			return new ModelAndView("chyba", "message", message);
		}
	}

	public void setOsobaManager(OsobaManager osobaManager) {
		this.osobaManager = osobaManager;
	}

}
