package cz.zcu.kiv.opencms.springmvcapp.controllers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.Controller;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.opencms.springmvcapp.services.OsobaManager;

public class OsobyPrehledController implements Controller {

	protected final Log logger = CmsLog.getLog(OsobyUvodController.class);
	
	private OsobaManager osobaManager;
	
	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.Controller#handleRequest(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	@Override
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
		List<Osoba> osobyArrayList = new ArrayList<Osoba>();
		
		logger.info("Nacita se seznam osob");
		osobyArrayList = osobaManager.getOsoby();
		logger.info("Seznam osob byl v poradku nacten");
		
		Map<String, Object> myModel = new HashMap<String, Object>();
		myModel.put("osoby", osobyArrayList);

		return  new ModelAndView("osobyprehled", "model", myModel);
	}

	public void setOsobaManager(OsobaManager osobaManager) {
        this.osobaManager = osobaManager;
    }

	
}
