package cz.zcu.kiv.opencms.springmvcapp.controllers;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.SimpleFormController;
import org.springframework.web.servlet.view.RedirectView;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.opencms.springmvcapp.services.OsobaManager;

public class ZalozOsobuFormController extends SimpleFormController {

	protected final Log logger = CmsLog.getLog(this.getClass());
	
	private OsobaManager osobaManager;

	public ModelAndView onSubmit(Object command)  throws ServletException {
		Osoba novaOsoba = (Osoba)command;
		logger.info("Ukladam osobu (login):" + novaOsoba.getLogin());
	
		osobaManager.ulozOsobu(novaOsoba);
		
		logger.info("Ulozena osoba (login):" + novaOsoba.getLogin());
		
		ModelAndView modelAndView = new ModelAndView(new RedirectView(getSuccessView()),"novaosoba", novaOsoba.getLogin());
		
		return modelAndView;
	}
	
	protected Object formBackingObject(HttpServletRequest request) throws ServletException {
		Osoba novaOsoba = new Osoba();

		logger.debug("zacatek metody formBackingObject");
		String id = (String)request.getParameter("id");
		if(id != null){
			int idInt;
			try{
				idInt = Integer.valueOf(id);
			}catch(NumberFormatException e) {
				logger.fatal("Chyba pri nacitani parametru pozadavku - spatny format parametru id! ",e);
				return novaOsoba;
			}
			
			novaOsoba = this.osobaManager.getOsobaById(idInt);
			logger.info("Aktualizuji osobu:" + novaOsoba.getLogin());
			if(novaOsoba == null){
				novaOsoba = new Osoba();
			}
		} else {
			logger.info("Vytvarim novou osobu:" + novaOsoba.getLogin());
		}
		
		return novaOsoba;
	}
	
	public void setOsobaManager(OsobaManager osobaManager) {
        this.osobaManager = osobaManager;
    }

}
