package cz.zcu.kiv.opencms.springmvcapp.controllers;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;
import org.springframework.validation.BindException;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.mvc.AbstractWizardFormController;

import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.opencms.springmvcapp.services.OsobaManager;

public class ZalozosobuKomplexniController extends AbstractWizardFormController {

	protected final Log logger = CmsLog.getLog(this.getClass());
	
	private OsobaManager osobaManager;
	
	public ZalozosobuKomplexniController(){
		setCommandName("osoba");
		setCommandClass(Osoba.class);
	}
	
	@Override
	protected ModelAndView processFinish(HttpServletRequest request, HttpServletResponse response, Object command,
			BindException errors) throws Exception {
		Osoba novaOsoba = (Osoba) command;
		logger.info("Nacitam novou osobu.");
		
		System.out.println("Process Finish");
		if(novaOsoba != null){
			logger.info("Ukladam osobu: " + novaOsoba.getLogin());
			this.osobaManager.ulozOsobu(novaOsoba);
			logger.info("Osoba: " + novaOsoba.getLogin() + " byla uspesne ulozena.");
		}
		return new ModelAndView(getInitialView());
	}
	
	

	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.AbstractWizardFormController#processCancel(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, java.lang.Object, org.springframework.validation.BindException)
	 */
	@Override
	protected ModelAndView processCancel(HttpServletRequest request, HttpServletResponse response,
			Object command, BindException errors) throws Exception {

		return new ModelAndView(getInitialView());
	}

	private String getInitialView() {
		return super.getPages()[super.getPages().length - 1];
	}

	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.AbstractWizardFormController#referenceData(javax.servlet.http.HttpServletRequest, int)
	 */
	@Override
	protected Map referenceData(HttpServletRequest request, int page) throws Exception {
		// TODO Auto-generated method stub
		return super.referenceData(request, page);
	}

	/* (non-Javadoc)
	 * @see org.springframework.web.servlet.mvc.AbstractFormController#formBackingObject(javax.servlet.http.HttpServletRequest)
	 */
	@Override
	protected Object formBackingObject(HttpServletRequest request) throws Exception {
		Osoba o = new Osoba();
		return o;
	}
	
	public void setOsobaManager(OsobaManager osobaManager) {
        this.osobaManager = osobaManager;
    }

}
