package cz.zcu.kiv.opencms.springmvcapp.services;

import java.io.Serializable;
import java.util.List;

import cz.zcu.kiv.db.model.osoby.Aktivita;
import cz.zcu.kiv.db.model.osoby.Osoba;

/**
 * Mezivrstva mezi controllery/business logikou a Dao vrstvou aplikace.
 * 
 * @author Tomas Peterka
 */
public interface OsobaManager extends Serializable {

	public Osoba getOsobaById(int id);

    public List<Osoba> getOsoby();
    
    public void ulozOsobu(Osoba osoba);

    public void smazOsobu(Osoba osoba);
    
    public Osoba getOsobaByLogin(String loginName);
    
    
    public List<Aktivita> getAktivity();
    
    public Aktivita getAktivitaById(int id);
    
    public Aktivita ulozAktivitu(Aktivita aktivita);
    
    public void smazAktivitu(Aktivita aktivita);
}
