package cz.zcu.kiv.opencms.springmvcapp.services;

import java.util.List;

import cz.zcu.kiv.db.dao.OsobaDao;
import cz.zcu.kiv.db.model.osoby.Aktivita;
import cz.zcu.kiv.db.model.osoby.Osoba;

/**
 * Mezivrstva mezi controllery/business logikou a Dao vrstvou aplikace.
 * 
 * @author Tomas Peterka
 */
public class OsobaManagerImpl implements OsobaManager {

	private static final long serialVersionUID = 2071390267398167253L;
	
	private OsobaDao osobaDao;

	
	@Override
	public Osoba getOsobaById(int id) {
		return osobaDao.getOsobaById(id);
	}

	@Override
	public Osoba getOsobaByLogin(String loginName) {
		return osobaDao.getOsobaByLogin(loginName);
	}

	@Override
	public List<Osoba> getOsoby() {
		return osobaDao.getOsoby();
	}

	@Override
	public void smazOsobu(Osoba osoba) {
		osobaDao.smazOsobu(osoba);		
	}

	@Override
	public void ulozOsobu(Osoba osoba) {
		osobaDao.ulozOsobu(osoba);		
	}
	
	public void setOsobaDao(OsobaDao osobaDao) {
        this.osobaDao = osobaDao;
    }

	@Override
	public Aktivita getAktivitaById(int id) {
		return osobaDao.getAktivitaById(id);
	}

	@Override
	public List<Aktivita> getAktivity() {
		return osobaDao.getAktivity();
	}

	@Override
	public void smazAktivitu(Aktivita aktivita) {
		osobaDao.smazAktivitu(aktivita);
	}

	@Override
	public Aktivita ulozAktivitu(Aktivita aktivita) {
		return osobaDao.ulozAktivitu(aktivita);
	}
}
