package cz.zcu.kiv.opencms.springmvcapp.validator;

import org.apache.commons.logging.Log;
import org.opencms.main.CmsLog;
import org.springframework.binding.message.MessageBuilder;
import org.springframework.binding.message.MessageContext;
import org.springframework.binding.validation.ValidationContext;

import cz.zcu.kiv.db.model.osoby.Aktivita;

/**
 * Trida pro validaci formulare pro vytvoreni aktivity ve WebFlow
 * @author Jaroslav Pavuk
 *
 */
public class AktivitaValidator {
	
	protected final Log logger = CmsLog.getLog(AktivitaValidator.class);
	
	public void validateZalozAktivitu(Aktivita aktivita, ValidationContext context) {
		MessageContext messages = context.getMessageContext();

		String popis = aktivita.getPopisCz();
		
		if(popis == null || popis.length() < 2){
			messages.addMessage(new MessageBuilder().error().source("popisCz").defaultText("Popis prilis kratky!").build());
		}
	}
}
