package cz.zcu.kiv.opencms.springmvcapp.controllers;

import java.util.Map;

import javax.annotation.Resource;

import cz.zcu.kiv.opencms.springmvcapp.services.OsobaManager;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.AbstractTransactionalJUnit4SpringContextTests;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.web.servlet.ModelAndView;

/**
 * Trida s testy pro controller.
 * 
 * @author Tomas Peterka
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {"classpath:controller-context.conf"})
public class OsobyPrehledControllerTest 
		extends AbstractTransactionalJUnit4SpringContextTests  {

	private MockHttpServletRequest request;
	protected OsobyPrehledController osobyPrehledController;
	protected OsobaManager osobaManager;
	
	
    /**
     * Metoda slouzi k inicializovani promenych potrebnych k testovani.
     */
    @Before
    public void setUp() {
        request = new MockHttpServletRequest(null, "POST", "/springmvcapp/osobyprehled.html");
    }
    
    /**
     * Metoda slouzi k uklidu po provedeni jednotlivych testu.
     */
    @After
    public void tearDown() {
        request = null;
    } 
    
    /**
     * Testovaci metoda.
     * 
     * @throws java.io.IOException
     * @throws javax.servlet.ServletException
     */
    @Test
    public void fooMethod() {
        assertNotNull(request);
    }   
    
    /**
     * Metoda s testy.
     * 
     * @throws Exception
     */
    @Test
    public void handleRequestView() throws Exception {
        ModelAndView modelAndView = osobyPrehledController.handleRequest(request, null);
        
        assertNotNull(modelAndView);
        assertNotNull(modelAndView.getViewName());
        assertEquals("osobyprehled", modelAndView.getViewName());
        
        Map myModel = (Map) modelAndView.getModel().get("model");
        assertNotNull(myModel);
        
    }
    
    @Resource
    public void setAddWordsFileController(OsobyPrehledController osobyPrehledController) {
        this.osobyPrehledController = osobyPrehledController;
    }
    
    @Resource
    public void setOsobaManager(OsobaManager osobaManager) {
        this.osobaManager = osobaManager;
    }

}
